package com.scbfkj.uni.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.messaging.simp.config.MessageBrokerRegistry;
import org.springframework.web.socket.config.annotation.EnableWebSocketMessageBroker;
import org.springframework.web.socket.config.annotation.StompEndpointRegistry;
import org.springframework.web.socket.config.annotation.WebSocketMessageBrokerConfigurer;

@Configuration
@EnableWebSocketMessageBroker
public class WebSocketConfig implements WebSocketMessageBrokerConfigurer {

    @Override
    public void configureMessageBroker(MessageBrokerRegistry config) {

//        对应 @SendTo 比如@SendTo("/topic/greeting")
        config.enableSimpleBroker("/topic");
//        对应 @MessageMapping 比如@MessageMapping("/hello") 会自动添加前缀路径形成的完整路径为/app/hello
        config.setApplicationDestinationPrefixes("/app");
    }

    @Override
    public void registerStompEndpoints(StompEndpointRegistry registry) {
//        建立连接的url
        registry.addEndpoint("/gs-guide-websocket").setAllowedOriginPatterns("*");
    }

}