package com.scbfkj.uni.api;

import com.jayway.jsonpath.JsonPath;
import com.scbfkj.uni.ControllerBaseTest;
import org.hamcrest.core.IsEqual;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.result.MockMvcResultHandlers;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;

@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
class SecurityApiTest extends ControllerBaseTest {



    @Test
    @Order(1)
    void getToken() throws Exception {

        mockMvc.perform(MockMvcRequestBuilders.post("/user/getToken")
                        .contentType(MediaType.APPLICATION_JSON_VALUE)
                        .content("""
                                {"appid":"test","appsecret":"test"}
                                """)
                        .cookie(cookie))

                .andExpect(MockMvcResultMatchers.status().isOk())
                .andExpect(MockMvcResultMatchers.jsonPath("code", IsEqual.equalTo("0")))
                .andDo(result -> {
                    String content = result.getResponse().getContentAsString();
                    SecurityApiTest.token = JsonPath.read(content, "$.returnData.token");
                })
                .andDo(MockMvcResultHandlers.print());
    }

    @Test
    @Order(2)
    void refreshToken() throws Exception {
        mockMvc.perform(MockMvcRequestBuilders.post("/user/refreshToken")
                        .contentType(MediaType.APPLICATION_JSON_VALUE)
//                        .header("token", token)
                        .cookie(cookie)
                                .content("")
                )

                .andExpect(MockMvcResultMatchers.status().isOk())
                .andExpect(MockMvcResultMatchers.jsonPath("code", IsEqual.equalTo("0")))
                .andDo(MockMvcResultHandlers.print());
    }

    @Test
    void testToken() {
    }

    @Test
    void getCode() {
    }

    @Test
    void forceLogin() {
    }

    @Test
    void login() {
    }

    @Test
    void getPermissions() {
    }

    @Test
    void changePwd() {
    }

    @Test
    void logOut() {
    }

    @Test
    void health() {
    }

    @Test
    void getPubKey() {
    }
}